## Classificatin

**Environment**

* torch 1.6

* transformers 4.1+

**Go train**

Download data from [GLUE](https://gluebenchmark.com/tasks).

Unzip all the tasks and put into `data/glue/`.

Take MRPC as example:

```bash
cd classification
python run_classifier_with_attendout.py --do_train --do_eval --learning_rate 2e-5 --max_seq_length 128 --train_batch_size 32 --eval_batch_size 32 --warmup_rate 0.06 --num_train_epochs 10 --data_dir data/glue --task_name mrpc --output_dir mrpc_roberta --step 12 --share_embedding
```

The result is saved in `mrpc_roberta/eval_results.txt`. Our result is:

```txt
Epoch 0: accuracy = 80.64 | loss = 5.096
Epoch 1: accuracy = 86.52 | loss = 4.077
Epoch 2: accuracy = 86.76 | loss = 4.141
Epoch 3: accuracy = 87.50 | loss = 3.717
Epoch 4: accuracy = 89.46 | loss = 4.497
Epoch 5: accuracy = 88.73 | loss = 4.899
Epoch 6: accuracy = 89.46 | loss = 5.649
Epoch 7: accuracy = 89.22 | loss = 5.767
Epoch 8: accuracy = 90.93 | loss = 5.934
Epoch 9: accuracy = 90.44 | loss = 5.941
```



## Multiple Choices

**Environment**

* torch 1.4/1.5

* transformers 2.8

The environment for mrc is kind of different.

**Go train**

Download data from [SWAG](https://github.com/rowanz/swagaf/tree/master/data).

Unzip and put into `data/swag/`.

```bash
cd multiple_choice
python run_multiple_choice_with_attendout.py --model_type bert --model_name_or_path bert-base-uncased --task_name swag --do_train --do_eval --data_dir data/swag/ --learning_rate 2e-5 --num_train_epochs 3 --max_seq_length 128 --output_dir swag_bert --per_gpu_eval_batch_size=8 --per_gpu_train_batch_size=8 --step 15 --load_model_path swag_bert/pytorch_model.bin
```

We only evaluate the last checkpoint. Our result is:

```txt
eval_acc = 81.57
eval_loss = 0.584
```

